//
//  PathSegment
//
//  Created by Shawn on 2007-11-06.
//

/*
PathSegment is used to store a 21-base stretch of scaffold
and staple crossover positions.  PathSegment instances are maintained
by a Path object, which is then drawn and manipulated by DrawPath.
*/

package edu.harvard.med.nano {
    
    import flash.utils.ByteArray; // for cloning PathSegments
    
    public class PathSegment {
        
        public var helixNum:int;
        public var segIndex:int;
        public var scafxover:Array;  // scaffold crossover positions
        public var stapxover:Array;  // staple crossover positions
        public var scafloop:Array;
        public var staploop:Array;
        public var stapbreak:Array;
        public var p0:PathSegment;
        public var p1:PathSegment;
        public var p2:PathSegment;
        public var drawSegment:DrawSegment;
        
        function PathSegment(helixNum:int, segIndex:int) {
            this.helixNum = helixNum;
            this.segIndex = segIndex;
            this.scafxover = new Array(21);
            this.scafloop = new Array(21);
            this.stapxover = new Array(21);
            this.staploop = new Array(21);
            this.stapbreak = new Array(21);
            for (var i:int = 0; i < 21; i++) {
                this.scafxover[i] = -1; //
                this.stapxover[i] = -1; //
                this.scafloop[i] = 0;   // length of scaffold loop
                this.staploop[i] = "";  // bases to add at 3' position
                this.stapbreak[i] = false;
            }
            
            this.drawSegment = new DrawSegment();
        }
        
        public function addScafXover(pos:int, target:int):void {
            this.scafxover[pos] = target;
            //trace(this.helixNum, this.segIndex, "addScafXover:", pos, target);
        }
        
        public function delScafXover(pos:int):void {
            
        }
        
        public function movScafXover(oldpos:int, newpos:int):void {
            
        }
        
        public function addStapXover(pos:int, target:int):void {
            this.stapxover[pos] = target;
        }
        
        public function delStapXover(pos:int):void {
            
        }
        
        public function movStapXover(oldpos:int, newpos:int):void {
            
        }
        
        private function clone(source:Object):*
        {
            var myBA:ByteArray = new ByteArray();
            myBA.writeObject(source);
            myBA.position = 0;
            return(myBA.readObject());
        }

        
    }
}
