//
//  SliceNode
//
//  Created by Shawn on 2007-10-18.
//

/*
A SliceNode is an x-y plane cross-sectional representation of a helix.
SliceNodes populate the slice array, and their data is what gets
displayed by the DrawSlice routines.
*/

package edu.harvard.med.nano
{
    import flash.display.*;
    import edu.harvard.med.nano.DrawSlice;
    //import flash.events.*;
    //import flash.text.*;
    
    public class SliceNode extends Sprite {
        // for debugging
        public var row:int;
        public var col:int;
        
        public var parity:int;
        public var p0neighbor:SliceNode;
        public var p1neighbor:SliceNode;
        public var p2neighbor:SliceNode;
        public var marked:Boolean;           // toggles when clicked
        public var pairedNeighbor:SliceNode; // external xover neighbor
        public var pairedPosition:int;
        public var number:int;               // helix number
        public var dist:int;
        public var drawNode:DrawNode;
        
        public function SliceNode(row:int, col:int)
        {
            this.row = row;
            this.col = col;
            this.parity = (row % 2) ^ (col % 2);
            this.p0neighbor = null;
            this.p1neighbor = null;
            this.p2neighbor = null;
            this.marked = false;
            this.pairedNeighbor = null;
            this.number = -1;
        }
    }
}
